from fastapi import APIRouter, HTTPException
from fastapi.responses import JSONResponse

from bsition.api.utils.jwt import write_token
from bsition.api.models.user import User
from bsition.backend.postgres import get_user_by_username_and_password

router = APIRouter()


@router.post("/login")
def login(user: User):
    if get_user_by_username_and_password(user.username, user.password) is not None:
        return JSONResponse(
            content={
                "access_token": write_token(user.dict()),
                "token_type": "bearer"
            },
            status_code=202)
    else:
        raise HTTPException(
            status_code=400,
            detail="User not found.",
        )
